#!/bin/bash


parseOpt43AsBoardId()
{
  local val=$1
  local idx=0
  
  [ -z "$val" ] && return
 
  G_RV=$1
  #hex2acsii $val
  
  return
}

parseOpt43AsAcsUrl()
{
  local val=$1
  local idx=0
  local subOpt=0
  local subOptLen=0
  local inc=0
  local subOptValue=""

  while [ ! -z "$val" ]
  do
    #locate first :
    idx=`expr index "$val" :`
    : $((idx = $idx - 1)) #decrement
    [ "$idx" == "-1" ] && return #: not found

    #get option
    subOpt=${val:0:$idx}
    : $((idx = $idx + 1)) #increment
    val=${val:$idx}
    hex2dec $subOpt
    subOpt=$?
    #echo "subOpt=$subOpt"

    #locate first :
    idx=`expr index "$val" :`
    : $((idx = $idx - 1)) #decrement
    [ "$idx" == "-1" ] && return #: not found

    #get option length
    subOptLen=${val:0:$idx}
    : $((idx = $idx + 1)) #increment
    val=${val:$idx}
    hex2dec $subOptLen
    subOptLen=$?
    subOptLen=$((subOptLen*3-1))

    subOptValue=${val:0:$subOptLen}

    #go to next option
    idx=$subOptLen
    : $((idx = $idx + 1)) #increment
    val=${val:$idx}

    if [ "$subOpt" != "1" -a "$subOpt" != "3" ]
    then #this is not url string
      continue
    fi
    hex2acsii $subOptValue

    #number of options
    : $((inc = $inc + 1)) #increment

    [ $inc -eq 1 ] && acsUrl1=$G_RV
    [ "$inc" == "2" ] && acsUrl2=$G_RV
    [ "$inc" == "3" ] && acsUrl3=$G_RV
    [ "$inc" == "4" ] && return
  done #end while
  return
}

getCircuitAndRemoteIdFromOpt82()
{
  local val=$1
  local idx=0
  local subOpt=0
  local subOptLen=0
  local inc=0
  local subOptValue=""

  while [ ! -z "$val" ]
  do
    #locate first :
    idx=`expr index "$val" :`
    : $((idx = $idx - 1)) #decrement
    [ "$idx" == "-1" ] && return #: not found

    #get option
    subOpt=${val:0:$idx}
    : $((idx = $idx + 1)) #increment
    val=${val:$idx}
    hex2dec $subOpt
    subOpt=$?
    #echo "subOpt=$subOpt"

    #locate first :
    idx=`expr index "$val" :`
    : $((idx = $idx - 1)) #decrement
    [ "$idx" == "-1" ] && return #: not found

    #get option length
    subOptLen=${val:0:$idx}
    : $((idx = $idx + 1)) #increment
    val=${val:$idx}
    hex2dec $subOptLen
    subOptLen=$?
    subOptLen=$((subOptLen*3-1))

    subOptValue=${val:0:$subOptLen}

    #go to next option
    idx=$subOptLen
    : $((idx = $idx + 1)) #increment
    val=${val:$idx}

    if [ "$subOpt" != "1" -a "$subOpt" != "2" ]
    then #this is circuitID nor RemoteID
      continue
    fi
    
    [ "$subOpt" == "1" ] && hex2acsii $subOptValue && circuitID=$G_RV
    [ "$subOpt" == "2" ] && hex2acsii $subOptValue && remoteID=$G_RV

    #number of options
    : $((inc = $inc + 1)) #increment
    
    [ "$inc" == "3" ] && return
    
  done #end while
  return
}

hex2dec()
{
  return $((0x$1))
}

hex2acsii()
{
  local val=$1
  local str=""
  local idx=0
  G_RV=""

  while [ ! -z "$val" ]
  do
    #locate first :
    idx=`expr index "$val" :`
    : $((idx = $idx - 1)) #decrement
    [ "$idx" == "-1" ] && idx=10 #: not found
    str=$str`printf "\\x"${val:0:$idx}""`

    : $((idx = $idx + 1)) #increment
    val=${val:$idx}

  done #end while

  G_RV=$str
  return
}
